/*___________________________________________________________________________*/
/* IBM Optimization Solutions and Library Optimization Library               */
/* ekkc.h - OSL C header file                                                */
/* (c) IBM Corp, 1990,1997 All rights reserved.                              */
/*                                                                           */
/* US Government Users Restricted Rights - Use, duplication, or disclosure   */
/* restricted by GAS ADP Schedule Contract with IBM Corp.                    */
/*___________________________________________________________________________*/
#if !defined(_EKKC_)
#define _EKKC_

/* EKK_INT is defined to be int on Sun and HP, long on other platforms */
#if defined(__64BIT__)
#define EKK_INT int
#else
#define EKK_INT long
#endif

#if defined(INTEL)&&!defined(LINUX)

#ifdef __cplusplus
extern "C"{
#endif
#include <string.h>

/* Temporary variables used in FORTRAN linkage */

static EKK_INT    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static EKK_INT    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;

/* OSL routines */
#ifndef OSLLIBAPI
#ifdef OSLMSDLL
#define OSLLINKAGE __stdcall
#define OSLLINKAGE_CB  __cdecl
#define OSLLIBAPI __declspec(dllimport)
#endif
#ifdef OSLMSSTAT
#define OSLLINKAGE __stdcall
#define OSLLINKAGE_CB  __cdecl
#define OSLLIBAPI
#endif
#if defined(OSLWCSTAT) || defined(OSLWCDLL)
#define OSLLINKAGE
#define OSLLINKAGE_CB  
#define OSLLIBAPI
#endif
#endif

OSLLIBAPI void OSLLINKAGE  EKKBASI(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKBASO(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKBCDO(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKBMPR(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKBMPS(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKBSLV(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKCGET(EKK_INT *,double *,char *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKCLCB(int *);
OSLLIBAPI void OSLLINKAGE  EKKCOL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKCOPY(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKCRSH(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKCSET(EKK_INT *,double *,char *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKDSCA(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKDSCB(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *,
               EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKDSCM(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKEMDL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKGEMV(EKK_INT *,double *,EKK_INT *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKGES(EKK_INT *,double *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKGTMD(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKGTMI(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKHIS(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKIGET(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKIMDL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,
               EKK_INT *,EKK_INT *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKINIT(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKINVT(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKISET(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKLMDL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *,double *,
               double *,double *,double *,EKK_INT *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKLPDC(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMPRE(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMPS(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMSAV(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMSET(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,
               EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMSLV(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKMSTR(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKNAME(EKK_INT *,double *,EKK_INT *,char *,EKK_INT*,EKK_INT *,
               char *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKNFES(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKNGET(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKNLBS(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKNMDL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *, double *,double *,double *,double *, double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKNSLV(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKNWMT(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKPMDL(EKK_INT *,double *,double *,double *,double *,double *,double *, EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKPOPS(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPRSL(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKPRTS(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPSHS(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPSSL(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKPTMD(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKPTMI(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKQMDL(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKQMPS(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKQPAR(EKK_INT *,double *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKQSLV(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKQRMD(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKRGCB(int *, void *);
OSLLIBAPI void OSLLINKAGE  EKKRGET(EKK_INT *,double *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKROW(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKRPTB(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKRSET(EKK_INT *,double *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKSBND(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKSCAL(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSEL(EKK_INT *,double *,char *,EKK_INT *,char *,char *,
              EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKSMAP(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSOBJ(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSOS(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSPAR(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSSLV(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKSTAT(EKK_INT *,double *);


OSLLIBAPI void OSLLINKAGE  EKKFCLS(EKK_INT *, char *, EKK_INT *);
OSLLIBAPI void OSLLINKAGE  EKKFOPN(EKK_INT *, char *, char *,
                      char *, char *, char *, 
                      EKK_INT *, EKK_INT *);

OSLLIBAPI void OSLLINKAGE  EKKFREW(EKK_INT *);
OSLLIBAPI double * OSLLINKAGE  ekkdspace95(EKK_INT);

/* Redefinition for C/C++ drivers  */

#define  ekkbasi(x1,x2,i1)         (ekk_i1=i1, EKKBASI(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBASO(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKBCDO(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBMPR(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)         (ekk_i1=i1, EKKBMPS(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkclcb(i1)               (ekk_s1=i1, EKKCLCB(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    EKKCGET(x1,x2,x3,&ekk_i1))

#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKCOL(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkcopy(x1,x2,i1)         (ekk_i1=i1, EKKCOPY(x1,x2,&ekk_i1))

#define  ekkcrsh(x1,x2,i1)         (ekk_i1=i1, EKKCRSH(x1,x2,&ekk_i1))

#define  ekkcset(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    EKKCSET(x1,x2,x3,&ekk_i1))

#define  ekkdsca(x1,x2,i1,i2)      (ekk_longlong=i1,ekk_i2=i2,  \
                                    EKKDSCA(x1,x2,&ekk_longlong,&ekk_i2))

#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                    EKKDSCB(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5, \
                                    &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkdscm(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKDSCM(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKEMDL(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   EKKFCLS(&ekk_i1,x1,x2))

/*
#if defined(OSLWCSTAT) || defined(OSLWCDLL)
#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, \
                                   ekk_i2=strlen(x1),ekk_i3=strlen(x2), \
                                   ekk_i4=strlen(x3),ekk_i5=strlen(x4), \
                                   ekk_i6=strlen(x5),ekk_i7=i2, \
                                   EKKFOPN(&ekk_i1,x1,x2, \
                                   x3,x4,x5,&ekk_i7,x6, \
                                   &ekk_i2,&ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
#else
*/
#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, \
                                   ekk_i2=strlen(x1),ekk_i3=strlen(x2), \
                                   ekk_i4=strlen(x3),ekk_i5=strlen(x4), \
                                   ekk_i6=strlen(x5),ekk_i7=i2, \
                                   EKKFOPN(&ekk_i1,x1,x2, \
                                   x3,x4, \
                                   x5,&ekk_i7,x6))
/*#endif*/

#define  ekkfrew(i1)               (ekk_i1=i1, \
                                   EKKFREW(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                   (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                    EKKGEMV(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                    &ekk_z2,x4))

#define  ekkges(x1,x2,i1,x3)       (ekk_i1=i1, EKKGES(x1,x2,&ekk_i1,x3))

#define  ekkgtmd(x1,x2,i1)         (ekk_i1=i1, EKKGTMD(x1,x2,&ekk_i1))

#define  ekkgtmi(x1,x2,i1)         (ekk_i1=i1, EKKGTMI(x1,x2,&ekk_i1))

#define  ekkhis(x1,x2,i1,x3)       (ekk_i1=i1, EKKHIS(x1,x2,&ekk_i1,x3))

#define  ekkiget(x1,x2,x3,i1)      (ekk_i1=i1, EKKIGET(x1,x2,x3,&ekk_i1))

#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    EKKIMDL(x1,x2,&ekk_i1,x3,&ekk_i2,x4, \
                                    x5,&ekk_i3,x6,x7,x8,x9))

#define  ekkinit(x1,x2)            (EKKINIT(x1,x2))

#define  ekkinvt(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKINVT(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkiset(x1,x2,x3,i1)      (ekk_i1=i1, EKKISET(x1,x2,x3,&ekk_i1))

#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    EKKLMDL(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))

#define  ekklpdc(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKLPDC(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmpre(x1,x2,i1)         (ekk_i1=i1,  \
                                    EKKMPRE(x1,x2,&ekk_i1))

#define  ekkmps(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKMPS(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmsav(x1,x2,i1,x3)      (ekk_i1=i1, EKKMSAV(x1,x2,&ekk_i1,x3))

#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                    EKKMSET(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))

#define  ekkmslv(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKMSLV(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmstr(x1,x2,i1,x3)      (ekk_i1=i1, EKKMSTR(x1,x2,&ekk_i1,x3))



#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   EKKNAME(x1,x2,&ekk_i1,x3, &ekk_i2, \
                                   &ekk_i3,x4, &ekk_i4,&ekk_i5))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKNFES(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)      (ekk_i1=i1, EKKNGET(x1,x2,x3,&ekk_i1))

#define  ekknlbs(x1,x2)            (EKKNLBS(x1,x2))

#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   EKKNMDL(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))

#define  ekknslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKNSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekknwmt(x1,x2,i1)         (ekk_i1=i1, EKKNWMT(x1,x2,&ekk_i1))

#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)         \
                                   (ekk_i1=i1,    \
                                    EKKPMDL(x1,x2,x3,x4,x5,x6,x7,&ekk_i1))

#define  ekkpops(x1,x2)            (EKKPOPS(x1,x2))

#define  ekkprsl(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKPRSL(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkprts(x1,x2)            (EKKPRTS(x1,x2))

#define  ekkpshs(x1,x2)            (EKKPSHS(x1,x2))

#define  ekkpssl(x1,x2,i1)         (ekk_i1=i1, EKKPSSL(x1,x2,&ekk_i1))

#define  ekkptmd(x1,x2,i1)         (ekk_i1=i1, EKKPTMD(x1,x2,&ekk_i1))

#define  ekkptmi(x1,x2,i1)         (ekk_i1=i1, EKKPTMI(x1,x2,&ekk_i1))

#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQMDL(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkqmps(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQMPS(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                   (ekk_z1=z1,ekk_z2=z2,  \
                                    EKKQPAR(x1,x2,x3,x4,&ekk_z1,&ekk_z2))

#define  ekkqslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqrmd(x1,x2,x3)         (EKKQRMD(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_s1=i1, EKKRGCB(&ekk_s1,x1))

#define  ekkrget(x1,x2,x3,i1)      (ekk_i1=i1, EKKRGET(x1,x2,x3,&ekk_i1))

#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKROW(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                    EKKRPTB(x1,x2,&ekk_i1,&ekk_i2, \
                                    &ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkrset(x1,x2,x3,i1)      (ekk_i1=i1, EKKRSET(x1,x2,x3,&ekk_i1))

#define  ekksbnd(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKSBND(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkscal(x1,x2)            (EKKSCAL(x1,x2))


#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   EKKSEL(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))


#define  ekksmap(x1,x2)            (EKKSMAP(x1,x2))

#define  ekksobj(x1,x2)            (EKKSOBJ(x1,x2))

#define  ekksos(x1,x2)             (EKKSOS(x1,x2))

#define  ekkspar(x1,x2)            (EKKSPAR(x1,x2))

#define  ekksslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKSSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkstat(x1,x2)            (EKKSTAT(x1,x2))

/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

#ifdef __cplusplus
}
#endif
#endif
#if defined(EKKC_RS6000)||defined(AS_400)||defined(LINUX)||defined(EKKC_OE)||defined(EKKC_ALPHA)||defined(EKKC_OMVS)

#ifdef __cplusplus
extern "C"{
#endif
#include <string.h>

/*  Temporary variables used in FORTRAN linkage  */

static EKK_INT    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static EKK_INT    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;

/* OSL routines */
#ifndef OSLLIBAPI
#ifdef OSLMSDLL
#define OSLLIBAPI      __declspec(dllimport)
#define OSLLINKAGE     __stdcall
#define OSLLINKAGE_CB
#else
#ifdef EKKC_OE
#define OSLLIBAPI
#define OSLLINKAGE
#ifdef __cplusplus
#define OSLLINKAGE_CB __cdecl
#else
#define OSLLINKAGE_CB 
#endif
#else
#define OSLLIBAPI
#define OSLLINKAGE
#define OSLLINKAGE_CB
#endif
#endif
#endif

OSLLIBAPI void OSLLINKAGE  ekkbasi(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkbaso(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkbcdo(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);


OSLLIBAPI void OSLLINKAGE  ekkbmpr(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkbmps(EKK_INT *,double *,EKK_INT *);

OSLLIBAPI void OSLLINKAGE  ekkbslv(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkcget(EKK_INT *,double *,char *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkclcb(int *);
OSLLIBAPI void OSLLINKAGE  ekkcol(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkcopy(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkcrsh(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkcset(EKK_INT *,double *,char *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkdsca(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkdscb(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *,
               EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkdscm(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkemdl(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkgemv(EKK_INT *,double *,EKK_INT *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkges(EKK_INT *,double *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkgtmd(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkgtmi(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkhis(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkiget(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkimdl(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,
               EKK_INT *,EKK_INT *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkinit(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkinvt(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkiset(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekklmdl(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *,double *,
               double *,double *,double *,EKK_INT *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekklpdc(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmpre(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmps(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmsav(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmset(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,
               EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmslv(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkmstr(EKK_INT *,double *,EKK_INT *,EKK_INT *);


OSLLIBAPI void OSLLINKAGE  ekkname(EKK_INT *,double *,EKK_INT *,char *,EKK_INT*,EKK_INT *,
               char *,EKK_INT *,EKK_INT *);

OSLLIBAPI void OSLLINKAGE  ekknfes(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);

OSLLIBAPI void OSLLINKAGE  ekknget(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekknlbs(EKK_INT *,double *);


OSLLIBAPI void OSLLINKAGE  ekknslv(EKK_INT *,double *,EKK_INT *,EKK_INT *);


OSLLIBAPI void OSLLINKAGE  ekknwmt(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkpmdl(EKK_INT *,double *,double *,double *,double *,
  double *,double *, EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkpops(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkprsl(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkprts(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkpshs(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkpssl(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkptmd(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkptmi(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkqmdl(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkqmps(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkqpar(EKK_INT *,double *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkqslv(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkqrmd(EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkrgcb(int *, void *);
OSLLIBAPI void OSLLINKAGE  ekkrget(EKK_INT *,double *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkrow(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkrptb(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkrset(EKK_INT *,double *,double *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekksbnd(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkscal(EKK_INT *,double *);

OSLLIBAPI void OSLLINKAGE  ekksel(EKK_INT *,double *,char *,EKK_INT *,char *,char *,
              EKK_INT *,EKK_INT *);

OSLLIBAPI void OSLLINKAGE  ekksmap(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekksobj(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekksos(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekkspar(EKK_INT *,double *);
OSLLIBAPI void OSLLINKAGE  ekksslv(EKK_INT *,double *,EKK_INT *,EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkstat(EKK_INT *,double *);

OSLLIBAPI void OSLLINKAGE  ekkfcls(EKK_INT *, char *, EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkfopn(EKK_INT *, char *, char *, 
                      char *, char *, char *, EKK_INT *, EKK_INT *);
OSLLIBAPI void OSLLINKAGE  ekkfrew(EKK_INT *);
OSLLIBAPI void * OSLLINKAGE  ekkdspace95(EKK_INT);

/* Redefinition for C/C++ drivers  */

#define  ekkbasi(x1,x2,i1)         (ekk_i1=i1, ekkbasi(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbaso(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkbcdo(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbmpr(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)         (ekk_i1=i1, ekkbmps(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    ekkcget(x1,x2,x3,&ekk_i1))

#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkcol(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkcopy(x1,x2,i1)         (ekk_i1=i1, ekkcopy(x1,x2,&ekk_i1))

#define  ekkcrsh(x1,x2,i1)         (ekk_i1=i1, ekkcrsh(x1,x2,&ekk_i1))

#define  ekkcset(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    ekkcset(x1,x2,x3,&ekk_i1))

#define  ekkdsca(x1,x2,i1,i2)      (ekk_longlong=i1,ekk_i2=i2,  \
                                    ekkdsca(x1,x2,&ekk_longlong,&ekk_i2))

#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                    ekkdscb(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5, \
                                    &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkdscm(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkdscm(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))


#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls(&ekk_i1,x1,x2))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))

#define  ekkfrew(i1)               (ekk_i1=i1, \
                                   ekkfrew(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                   (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                    ekkgemv(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                    &ekk_z2,x4))

#define  ekkges(x1,x2,i1,x3)       (ekk_i1=i1, ekkges(x1,x2,&ekk_i1,x3))

#define  ekkgtmd(x1,x2,i1)         (ekk_i1=i1, ekkgtmd(x1,x2,&ekk_i1))

#define  ekkgtmi(x1,x2,i1)         (ekk_i1=i1, ekkgtmi(x1,x2,&ekk_i1))

#define  ekkhis(x1,x2,i1,x3)       (ekk_i1=i1, ekkhis(x1,x2,&ekk_i1,x3))

#define  ekkiget(x1,x2,x3,i1)      (ekk_i1=i1, ekkiget(x1,x2,x3,&ekk_i1))

#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekkimdl(x1,x2,&ekk_i1,x3,&ekk_i2,x4, \
                                    x5,&ekk_i3,x6,x7,x8,x9))

#define  ekkinit(x1,x2)            (ekkinit(x1,x2))

#define  ekkinvt(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkinvt(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkiset(x1,x2,x3,i1)      (ekk_i1=i1, ekkiset(x1,x2,x3,&ekk_i1))

#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekklmdl(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))

#define  ekklpdc(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekklpdc(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmpre(x1,x2,i1)         (ekk_i1=i1,  \
                                    ekkmpre(x1,x2,&ekk_i1))

#define  ekkmps(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkmps(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmsav(x1,x2,i1,x3)      (ekk_i1=i1, ekkmsav(x1,x2,&ekk_i1,x3))

#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                    ekkmset(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))

#define  ekkmslv(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkmslv(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmstr(x1,x2,i1,x3)      (ekk_i1=i1, ekkmstr(x1,x2,&ekk_i1,x3))



#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname(x1,x2,&ekk_i1,x3, &ekk_i2, \
                                   &ekk_i3,x4, &ekk_i4,&ekk_i5))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)      (ekk_i1=i1, ekknget(x1,x2,x3,&ekk_i1))

#define  ekknlbs(x1,x2)            (ekknlbs(x1,x2))


#define  ekknslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknslv(x1,x2,&ekk_i1,&ekk_i2))




#define  ekknwmt(x1,x2,i1)         (ekk_i1=i1, ekknwmt(x1,x2,&ekk_i1))

#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)         \
                                   (ekk_i1=i1,    \
                                    ekkpmdl(x1,x2,x3,x4,x5,x6,x7,&ekk_i1))

#define  ekkpops(x1,x2)            (ekkpops(x1,x2))

#define  ekkprsl(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkprsl(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkprts(x1,x2)            (ekkprts(x1,x2))

#define  ekkpshs(x1,x2)            (ekkpshs(x1,x2))

#define  ekkpssl(x1,x2,i1)         (ekk_i1=i1, ekkpssl(x1,x2,&ekk_i1))

#define  ekkptmd(x1,x2,i1)         (ekk_i1=i1, ekkptmd(x1,x2,&ekk_i1))

#define  ekkptmi(x1,x2,i1)         (ekk_i1=i1, ekkptmi(x1,x2,&ekk_i1))

#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqmdl(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkqmps(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqmps(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                   (ekk_z1=z1,ekk_z2=z2,  \
                                    ekkqpar(x1,x2,x3,x4,&ekk_z1,&ekk_z2))

#define  ekkqslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqrmd(x1,x2,x3)         (ekkqrmd(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)      (ekk_i1=i1, ekkrget(x1,x2,x3,&ekk_i1))

#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkrow(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                    ekkrptb(x1,x2,&ekk_i1,&ekk_i2, \
                                    &ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkrset(x1,x2,x3,i1)      (ekk_i1=i1, ekkrset(x1,x2,x3,&ekk_i1))

#define  ekksbnd(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekksbnd(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkscal(x1,x2)            (ekkscal(x1,x2))


#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))


#define  ekksmap(x1,x2)            (ekksmap(x1,x2))

#define  ekksobj(x1,x2)            (ekksobj(x1,x2))

#define  ekksos(x1,x2)             (ekksos(x1,x2))

#define  ekkspar(x1,x2)             (ekkspar(x1,x2))

#define  ekksslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekksslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkstat(x1,x2)            (ekkstat(x1,x2))

/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

#ifdef __cplusplus
}
#endif
#endif
#ifdef EKKC_SUN
/* IBM Optimization Subroutine Library (OSL) (5765-128)      */
/* ekkc.h - OSL C header file for Sun-4/SPARCstation Systems */
/* Restricted Materials of IBM                               */
/* Copyright: International Business Machines Corp, 1997     */
#endif
#ifdef EKKC_HP
/* IBM Optimization Subroutine Library (OSL) (5765-135)      */
/* ekkc.h - OSL C header file for HP-PA RISC Systems         */
/* Restricted Materials of IBM                               */
/* Copyright: International Business Machines Corp, 1997     */
#endif
#if defined(EKKC_SUN) || defined(EKKC_HP)

#ifdef __cplusplus
extern "C"{
#endif 
#include <string.h>

#undef EKK_INT
#define EKK_INT int
 
/* Temporary variables used in redefinitions */
static EKK_INT     ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static EKK_INT     ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static EKK_INT     ekk_s1;
 
/* Redefinition of OSL user-callables */
#define  ekkbasi(x1,x2,i1)        (ekk_i1=i1, ekkbasi_(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbaso_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkbcdo_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbmpr_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)        (ekk_i1=i1, ekkbmps_(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcget_(x1,x2,x3,&ekk_i1))
 
#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkcol_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5))
 
#define  ekkcopy(x1,x2,i1)        (ekk_i1=i1, ekkcopy_(x1,x2,&ekk_i1))
 
#define  ekkcrsh(x1,x2,i1)        (ekk_i1=i1, ekkcrsh_(x1,x2,&ekk_i1))
 
#define  ekkcset(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcset_(x1,x2,x3,&ekk_i1))
 
#define  ekkdsca(x1,x2,i1,i2)     (ekk_longlong=i1,ekk_i2=i2,  \
                                   ekkdsca_(x1,x2,&ekk_longlong,&ekk_i2))
 
#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                   ekkdscb_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkdscm(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkdscm_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl_(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls_(&ekk_i1,x1,x2))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes_(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn_(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))


#define  ekkfrew(i1)              (ekk_i1=i1, \
                                  ekkfrew_(&ekk_i1))
 
#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                  (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                   ekkgemv_(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                   &ekk_z2,x4))
 
#define  ekkges(x1,x2,i1,x3)      (ekk_i1=i1, ekkges_(x1,x2,&ekk_i1,x3))
 
#define  ekkgtmd(x1,x2,i1)        (ekk_i1=i1, ekkgtmd_(x1,x2,&ekk_i1))
 
#define  ekkgtmi(x1,x2,i1)        (ekk_i1=i1, ekkgtmi_(x1,x2,&ekk_i1))
 
#define  ekkhis(x1,x2,i1,x3)      (ekk_i1=i1, ekkhis_(x1,x2,&ekk_i1,x3))
 
#define  ekkiget(x1,x2,x3,i1)     (ekk_i1=i1, ekkiget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekkimdl_(x1,x2,&ekk_i1,x3, \
                                   &ekk_i2,x4, \
                                   x5,&ekk_i3,x6,x7,x8,x9))
 
#define  ekkinit(x1,x2)           (ekkinit_(x1,x2))
 
#define  ekkinvt(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkinvt_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkiset(x1,x2,x3,i1)     (ekk_i1=i1, ekkiset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekklmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))
 
#define  ekklpdc(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekklpdc_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmpre(x1,x2,i1)        (ekk_i1=i1, ekkmpre_(x1,x2,&ekk_i1))
 
#define  ekkmps(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmps_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmsav(x1,x2,i1,x3)     (ekk_i1=i1, ekkmsav_(x1,x2,&ekk_i1, \
                                   x3))
 
#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                   ekkmset_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))
 
#define  ekkmslv(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmslv_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmstr(x1,x2,i1,x3)     (ekk_i1=i1, ekkmstr_(x1,x2, \
                                   &ekk_i1,x3))
 
#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname_(x1,x2,&ekk_i1,x3,&ekk_i2, \
                                   &ekk_i3,x4,&ekk_i4,&ekk_i5))
 
#define  ekknget(x1,x2,x3,i1)     (ekk_i1=i1, ekknget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekknlbs(x1,x2)           (ekknlbs_(x1,x2))
 
#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekknmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))
 
#define  ekknslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2, \
                                   ekknslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekknwmt(x1,x2,i1)        (ekk_i1=i1, ekknwmt_(x1,x2,&ekk_i1))
 
#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)  \
                                  (ekk_i1=i1,  \
                                   ekkpmdl_(x1,x2,x3,x4,x5,x6,x7, \
                                   &ekk_i1))
 
#define  ekkpops(x1,x2)           (ekkpops_(x1,x2))
 
#define  ekkprsl(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkprsl_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkprts(x1,x2)           (ekkprts_(x1,x2))
 
#define  ekkpshs(x1,x2)           (ekkpshs_(x1,x2))
 
#define  ekkpssl(x1,x2,i1)        (ekk_i1=i1, ekkpssl_(x1,x2,&ekk_i1))
 
#define  ekkptmd(x1,x2,i1)        (ekk_i1=i1, ekkptmd_(x1,x2,&ekk_i1))
 
#define  ekkptmi(x1,x2,i1)        (ekk_i1=i1, ekkptmi_(x1,x2,&ekk_i1))
 
#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkqmps(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmps_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                  (ekk_z1=z1,ekk_z2=z2,  \
                                   ekkqpar_(x1,x2,x3,x4,&ekk_z1, \
                                   &ekk_z2))
 
#define  ekkqslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqrmd(x1,x2,x3)         (ekkqrmd_(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)     (ekk_i1=i1, ekkrget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkrow_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                   ekkrptb_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkrset(x1,x2,x3,i1)     (ekk_i1=i1, ekkrset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekksbnd(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksbnd_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkscal(x1,x2)           (ekkscal_(x1,x2))
 
#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel_(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))
 
#define  ekksmap(x1,x2)           (ekksmap_(x1,x2))
 
#define  ekksmdl(x1,x2,i1,i2,i3,i4)   \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekksmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4))
 
#define  ekksobj(x1,x2)           (ekksobj_(x1,x2))
 
#define  ekksos(x1,x2)            (ekksos_(x1,x2))

#define  ekkspar(x1,x2)           (ekkspar_(x1,x2))
 
#define  ekksslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkstat(x1,x2)           (ekkstat_(x1,x2))
 
/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

/* OSL user-callable prototypes */
void  ekkbasi_(EKK_INT *,double *,EKK_INT *);
void  ekkbaso_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkbcdo_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkbmpr_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkbmps_(EKK_INT *,double *,EKK_INT *);
void  ekkbslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
/* void  ekkclcb(EKK_INT *);  */
void  ekkcget_(EKK_INT *,double *,char *,EKK_INT *);
void  ekkcol_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *, EKK_INT *);
void  ekkcopy_(EKK_INT *,double *,EKK_INT *);
void  ekkcrsh_(EKK_INT *,double *,EKK_INT *);
void  ekkcset_(EKK_INT *,double *,char *,EKK_INT *);
void  ekkdsca_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkdscb_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkdscm_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkemdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkfcls_(EKK_INT *,char *,EKK_INT *);
void  ekkfopn_(EKK_INT *,char *,char *,char *,char *,char *,EKK_INT *,EKK_INT *);
void  ekkfrew_(EKK_INT *);
void  ekkgemv_(EKK_INT *,double *,EKK_INT *,double *,double *,double *, double *);
void  ekkges_ (EKK_INT *,double *,EKK_INT *,double *);
void  ekkgtmd_(EKK_INT *,double *,EKK_INT *);
void  ekkgtmi_(EKK_INT *,double *,EKK_INT *);
void  ekkhis_ (EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkiget_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkimdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *,EKK_INT *,double *,double *);
void  ekkinit_(EKK_INT *,double *);
void  ekkinvt_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkiset_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekklmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *,double *,double *,double *,double *, EKK_INT *,EKK_INT *,double *);
void  ekklpdc_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmpre_(EKK_INT *,double *,EKK_INT *);
void  ekkmps_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmsav_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkmset_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmstr_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkname_(EKK_INT *,double *,EKK_INT *,char *,EKK_INT *,EKK_INT *, char *,EKK_INT *,EKK_INT *);
void  ekknfes_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekknget_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekknlbs_(EKK_INT *,double *);
void  ekknmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *, double *,double *,double *,double *, double *,double *,double *);
void  ekknslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekknwmt_(EKK_INT *,double *,EKK_INT *);
void  ekkpmdl_(EKK_INT *,double *,double *,double *,double *, double *,double *,EKK_INT *);
void  ekkpops_(EKK_INT *,double *);
void  ekkprsl_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkprts_(EKK_INT *,double *);
void  ekkpshs_(EKK_INT *,double *);
void  ekkpssl_(EKK_INT *,double *,EKK_INT *);
void  ekkptmd_(EKK_INT *,double *,EKK_INT *);
void  ekkptmi_(EKK_INT *,double *,EKK_INT *);
void  ekkqmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *);
void  ekkqmps_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkqpar_(EKK_INT *,double *,double *,double *,double *, double *);
void  ekkqslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkqrmd_(EKK_INT *,double *,EKK_INT *);
/* void  ekkrgcb(EKK_INT *,void *);*/
void  ekkrget_(EKK_INT *,double *,double *,EKK_INT *);
void  ekkrow_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *, EKK_INT *);
void  ekkrptb_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *);
void  ekkrset_(EKK_INT *,double *,double *,EKK_INT *);
void  ekksbnd_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkscal_(EKK_INT *,double *);
void  ekksel_ (EKK_INT *,double *,char *,EKK_INT *,char *, char *,EKK_INT *,EKK_INT *);
void  ekksmap_(EKK_INT *,double *);
void  ekksmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekksobj_(EKK_INT *,double *);
void  ekksos_(EKK_INT *,double *);
void  ekkspar_(EKK_INT *,double *);
void  ekksslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkstat_(EKK_INT *,double *);

#ifdef __cplusplus
}
#endif
#endif 
#ifdef EKKC_SGI
/* IBM Optimization Subroutine Library (OSL) (5765-136)       */
/* ekkc.h - OSL C header file for Silicon Graphics Systems    */
/* Restricted Materials of IBM                                */
/* Copyright: International Business Machines Corp, 1997      */

#ifdef __cplusplus
extern "C"{
#endif 
#include <string.h>
 
/* Temporary variables used in redefinitions */
#if 0
static EKK_INT    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static EKK_INT    ekk_longlong;
#else
static EKK_INT     ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static EKK_INT     ekk_longlong;
#endif
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;
 
/* Redefinition of OSL user-callables */
#define  ekkbasi(x1,x2,i1)        (ekk_i1=i1, ekkbasi_(x1,x2,&ekk_i1))
 
#define  ekkbaso(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbaso_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkbcdo(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkbcdo_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkbmpr(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbmpr_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)        (ekk_i1=i1, ekkbmps_(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcget_(x1,x2,x3,&ekk_i1))
 
#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkcol_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5))
 
#define  ekkcopy(x1,x2,i1)        (ekk_i1=i1, ekkcopy_(x1,x2,&ekk_i1))
 
#define  ekkcrsh(x1,x2,i1)        (ekk_i1=i1, ekkcrsh_(x1,x2,&ekk_i1))
 
#define  ekkcset(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcset_(x1,x2,x3,&ekk_i1))
 
#define  ekkdsca(x1,x2,i1,i2)     (ekk_longlong=i1,ekk_i2=i2,  \
                                   ekkdsca_(x1,x2,&ekk_longlong,&ekk_i2))
 
#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                   ekkdscb_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkdscm(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkdscm_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl_(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls_(&ekk_i1,x1,x2))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn_(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))


#define  ekkfrew(i1)              (ekk_i1=i1, \
                                  ekkfrew_(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                  (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                   ekkgemv_(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                   &ekk_z2,x4))
 
#define  ekkges(x1,x2,i1,x3)      (ekk_i1=i1, ekkges_(x1,x2,&ekk_i1,x3))
 
#define  ekkgtmd(x1,x2,i1)        (ekk_i1=i1, ekkgtmd_(x1,x2,&ekk_i1))
 
#define  ekkgtmi(x1,x2,i1)        (ekk_i1=i1, ekkgtmi_(x1,x2,&ekk_i1))
 
#define  ekkhis(x1,x2,i1,x3)      (ekk_i1=i1, ekkhis_(x1,x2,&ekk_i1,x3))
 
#define  ekkiget(x1,x2,x3,i1)     (ekk_i1=i1, ekkiget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekkimdl_(x1,x2,&ekk_i1,x3, \
                                   &ekk_i2,x4, \
                                   x5,&ekk_i3,x6,x7,x8,x9))
 
#define  ekkinit(x1,x2)           (ekkinit_(x1,x2))
 
#define  ekkinvt(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkinvt_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkiset(x1,x2,x3,i1)     (ekk_i1=i1, ekkiset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekklmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))
 
#define  ekklpdc(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekklpdc_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmpre(x1,x2,i1)        (ekk_i1=i1, ekkmpre_(x1,x2,&ekk_i1))
 
#define  ekkmps(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmps_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmsav(x1,x2,i1,x3)     (ekk_i1=i1, ekkmsav_(x1,x2,&ekk_i1, \
                                   x3))
 
#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                   ekkmset_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))
 
#define  ekkmslv(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmslv_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmstr(x1,x2,i1,x3)     (ekk_i1=i1, ekkmstr_(x1,x2, \
                                   &ekk_i1,x3))
 
#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname_(x1,x2,&ekk_i1,x3,&ekk_i2, \
                                   &ekk_i3,x4,&ekk_i4,&ekk_i5))
 
#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes_(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)     (ekk_i1=i1, ekknget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekknlbs(x1,x2)           (ekknlbs_(x1,x2))
 
#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekknmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))
 
#define  ekknslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2, \
                                   ekknslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekknwmt(x1,x2,i1)        (ekk_i1=i1, ekknwmt_(x1,x2,&ekk_i1))
 
#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)  \
                                  (ekk_i1=i1,  \
                                   ekkpmdl_(x1,x2,x3,x4,x5,x6,x7, \
                                   &ekk_i1))
 
#define  ekkpops(x1,x2)           (ekkpops_(x1,x2))
 
#define  ekkprsl(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkprsl_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkprts(x1,x2)           (ekkprts_(x1,x2))
 
#define  ekkpshs(x1,x2)           (ekkpshs_(x1,x2))
 
#define  ekkpssl(x1,x2,i1)        (ekk_i1=i1, ekkpssl_(x1,x2,&ekk_i1))
 
#define  ekkptmd(x1,x2,i1)        (ekk_i1=i1, ekkptmd_(x1,x2,&ekk_i1))
 
#define  ekkptmi(x1,x2,i1)        (ekk_i1=i1, ekkptmi_(x1,x2,&ekk_i1))
 
#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkqmps(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmps_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                  (ekk_z1=z1,ekk_z2=z2,  \
                                   ekkqpar_(x1,x2,x3,x4,&ekk_z1, \
                                   &ekk_z2))
 
#define  ekkqslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqrmd(x1,x2,x3)         (ekkqrmd_(x1,x2,x3))
 
#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)     (ekk_i1=i1, ekkrget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkrow_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                   ekkrptb_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkrset(x1,x2,x3,i1)     (ekk_i1=i1, ekkrset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekksbnd(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksbnd_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkscal(x1,x2)           (ekkscal_(x1,x2))
 
#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel_(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))
 
#define  ekksmap(x1,x2)           (ekksmap_(x1,x2))
 
#define  ekksmdl(x1,x2,i1,i2,i3,i4)   \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekksmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4))
 
#define  ekksobj(x1,x2)           (ekksobj_(x1,x2))
 
#define  ekksos(x1,x2)            (ekksos_(x1,x2))

#define  ekkspar(x1,x2)           (ekkspar_(x1,x2))
 
#define  ekksslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkstat(x1,x2)           (ekkstat_(x1,x2))
 
 
/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

/* OSL user-callable prototypes */
void  ekkbasi_(EKK_INT *,double *,EKK_INT *);
void  ekkbaso_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkbcdo_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkbmpr_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkbmps_(EKK_INT *,double *,EKK_INT *);
void  ekkbslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkcget_(EKK_INT *,double *,char *,EKK_INT *);
/*void  ekkclcb(int *);*/
void  ekkcol_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *, EKK_INT *);
void  ekkcopy_(EKK_INT *,double *,EKK_INT *);
void  ekkcrsh_(EKK_INT *,double *,EKK_INT *);
void  ekkcset_(EKK_INT *,double *,char *,EKK_INT *);
void  ekkdsca_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkdscb_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkdscm_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkemdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkfcls_(EKK_INT *,char *,EKK_INT *);
void  ekkfopn_(EKK_INT *,char *,char *,char *,char *,char *,EKK_INT *,EKK_INT *);
void  ekkfrew_(EKK_INT *);
void  ekkgemv_(EKK_INT *,double *,EKK_INT *,double *,double *,double *, double *);
void  ekkges_ (EKK_INT *,double *,EKK_INT *,double *);
void  ekkgtmd_(EKK_INT *,double *,EKK_INT *);
void  ekkgtmi_(EKK_INT *,double *,EKK_INT *);
void  ekkhis_ (EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkiget_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkimdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *,EKK_INT *,double *,double *);
void  ekkinit_(EKK_INT *,double *);
void  ekkinvt_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkiset_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekklmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *,double *,double *,double *,double *, EKK_INT *,EKK_INT *,double *);
void  ekklpdc_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmpre_(EKK_INT *,double *,EKK_INT *);
void  ekkmps_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmsav_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkmset_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekkmstr_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkname_(EKK_INT *,double *,EKK_INT *,char *,EKK_INT *,EKK_INT *, char *,EKK_INT *,EKK_INT *);
void  ekknfes_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekknget_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekknlbs_(EKK_INT *,double *);
void  ekknmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *,EKK_INT *, double *,double *,double *,double *, double *,double *,double *);
void  ekknslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekknwmt_(EKK_INT *,double *,EKK_INT *);
void  ekkpmdl_(EKK_INT *,double *,double *,double *,double *, double *,double *,EKK_INT *);
void  ekkpops_(EKK_INT *,double *);
void  ekkprsl_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkprts_(EKK_INT *,double *);
void  ekkpshs_(EKK_INT *,double *);
void  ekkpssl_(EKK_INT *,double *,EKK_INT *);
void  ekkptmd_(EKK_INT *,double *,EKK_INT *);
void  ekkptmi_(EKK_INT *,double *,EKK_INT *);
void  ekkqmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, double *);
void  ekkqmps_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkqpar_(EKK_INT *,double *,double *,double *,double *, double *);
void  ekkqslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkqrmd_(EKK_INT *,double *,EKK_INT *);
/*void  ekkrgcb(int *,void *);*/
void  ekkrget_(EKK_INT *,double *,double *,EKK_INT *);
void  ekkrow_ (EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,double *, EKK_INT *);
void  ekkrptb_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *, EKK_INT *);
void  ekkrset_(EKK_INT *,double *,double *,EKK_INT *);
void  ekksbnd_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkscal_(EKK_INT *,double *);
void  ekksel_ (EKK_INT *,double *,char *,EKK_INT *,char *, char *,EKK_INT *,EKK_INT *);
void  ekksmap_(EKK_INT *,double *);
void  ekksmdl_(EKK_INT *,double *,EKK_INT *,EKK_INT *,EKK_INT *,EKK_INT *);
void  ekksobj_(EKK_INT *,double *);
void  ekksos_(EKK_INT *,double *);
void  ekkspar_(EKK_INT *,double *);
void  ekksslv_(EKK_INT *,double *,EKK_INT *,EKK_INT *);
void  ekkstat_(EKK_INT *,double *);

#ifdef __cplusplus
}
#endif
#endif
#endif
